#include <Adafruit_NeoPixel.h>

#define DATAPIN A0
#define NUMBER_OF_PIXELS 7

byte hell = 25;
int wait1 = 50;
int wait2 = 20;


// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
// Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUMBER_OF_PIXELS, DATAPIN, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUMBER_OF_PIXELS, DATAPIN, NEO_GRB + NEO_KHZ800);


void setup() {
  strip.begin();
  strip.show();   // Initialize all pixels to 'off'
}


void loop() {
  // Ein paar Beispiel-Funktionen

  // Vibrieren: Alle Pixel gleichzeitig ein / ausschalten, in schneller Folge und 30 Wiederholungen
  // vibrieren(ROT, GRÜN, BLAU, EIN-Zeit, AUS-Zeit);
  // vibrieren(10, 40, 20, 10, 20);
  // vibrieren(50, 0, 0, 10, 20);


  // Alle ausschalten
  //  allOff();
  //  delay(1000);


  // Pixel für Pixel nach der Reihe mit einer Farbe einschalten (bis alle leuchten).
  // colorWipe(stripColor(ROT, GRÜN, BLAU), WarteZeit);   // WarteZeit: max. 255
  // colorWipe(strip.Color(255, 0, 0), 50);   // Red
  // delay(300);
  // colorWipe(strip.Color(0, 255, 0), 50);   // Green
  // delay(300);
  // colorWipe(strip.Color(0, 0, 255), 50);   // Blue
  // delay(300);


  // Theater pixel chase. Lauflicht mit jeweils 3 Pixeln. 
  // Es leuchten also gleichzeitig: 1, 4, 7, 10... danach 2, 5, 8, 11... danach 3, 6, 9, 12 ... etc)#
  // theaterChase(strip.Color(ROT, GRÜN, BLAU), WarteZeit);    // WarteZeit: max. 255
  // theaterChase(strip.Color(127, 127, 127), 50); // White
  // theaterChase(strip.Color(127,   0,   0), 50); // Red
  // theaterChase(strip.Color(  0,   0, 127), 50); // Blue


  // Regenbogen - alle Pixel haben immer dieselbe Farbe
  // rainbow(WarteZeit);   // WarteZeit: max. 255
  // rainbow(20);


  // Regenbogen - läuft den Streifen entlang
  // rainbowCycle(WarteZeit);   // WarteZeit: max. 255
  // rainbowCycle(20);


  // Kombination Theater Chase und Regenbogen
  // theaterChaseRainbow(WarteZeit);   // WarteZeit: max. 255
  // theaterChaseRainbow(30);

}




// ##################  F u n k t i o n e n  #######################
// alle Pixel ausschalten
void allOff() {
  for (byte i = 0; i < NUMBER_OF_PIXELS; i++) {
    strip.setPixelColor(i, 0, 0, 0);
  }
  strip.show();
}

// Alle Pixel gleichzeitig ein / ausschalten, in schneller Folge
void vibrieren(byte r, byte g, byte b, int wait_on, int wait_off) {
  for(int j= 0; j<30; j++){
    for (int i = 0; i < strip.numPixels(); i++) {
      strip.setPixelColor(i, r, g, b);
    }
    strip.show();
    delay(wait_on);
    for (int i = 0; i < strip.numPixels(); i++) {
      strip.setPixelColor(i, 0);
    }
    strip.show();
    delay(wait_off);
  }
}

// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}

// ------------------------------------------------
void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  if(WheelPos < 85) {
    return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } 
  else if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } 
  else {
    WheelPos -= 170;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
}









